#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl

use strict;
use warnings;

use XAD::registry;
my $LDAP_ERR_DUP_ACL = 20;
my $debug = 0;

sub update_acls {
    my $mapped_domain_nc = registry::getReg("Mapped Domain NC");
    my $temp_file = "/var/opt/novell/xad/ds/domain/domain_nc.ldif";
    if (not -e $temp_file) {
        open LDIFFILE, ">$temp_file" or die ("Could not open the LDIF file\n");
        print LDIFFILE "dn: $mapped_domain_nc\n";
        print LDIFFILE "changetype: modify\n";
        print LDIFFILE "add: ACL\n";
        print LDIFFILE "ACL: 7#subtree#[This]#[Entry Rights]\n";
        print LDIFFILE "ACL: 3#subtree#[This]#[All Attributes Rights]\n";
        close LDIFFILE;
    }

    my $ldapmodify_cmd = "LDAPCONF=/etc/opt/novell/xad/openldap/ldap.conf /usr/bin/ldapmodify -Y EXTERNAL -Q -c";

    print "Executing $ldapmodify_cmd -f $temp_file > /dev/null 2>&1 \n" if ($debug);
    my @output = `$ldapmodify_cmd -f $temp_file > /dev/null 2>&1`;
    if ( $? && $? == $LDAP_ERR_DUP_ACL) {

        my $err = $? >> 8;
        chomp (@output);
        print "Couldn't update the ACLs on the domain root container: @output : $err \n";
        exit -1;
    }
    else {
        print "Successfully updated the ACLs on the domain root container\n";
    }
}

update_acls;